/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;
/**
 * An orientation object.
 */

public class Orient 
{
	Twist pitch;
	Twist yaw;
	Twist roll;
	double pitchAngle;
	double yawAngle;
	double rollAngle;

	public Orient() { this(0, 0, 0); 		//{{INIT_CONTROLS
		//}}
}

	public Orient(Orient o1) 
	{
	 this.pitch = o1.pitch;
	 this.yaw = o1.yaw;
	 this.roll = o1.roll;
	 this.pitchAngle = o1.pitchAngle;
	 this.yawAngle = o1.yawAngle;
	 this.rollAngle = o1.rollAngle;
	}

	public Orient(int a, int b, int c) 
	{
		this((double)a, (double)b, (double)c);
	}

	public Orient(double a, double b, double c) 
	{
		pitchAngle = a;
		yawAngle = b;
		rollAngle = c;
		pitch = new Twist(a);
		yaw = new Twist(b);
		roll = new Twist(c);
	}

	public Orient negative() 
	{
		return new Orient(-pitchAngle, -yawAngle, -rollAngle);
	}
	
	//{{DECLARE_CONTROLS
	//}}
}	

/**
 * Encapsulated angle.
 */

	
 class Twist 
 {
	double cosine;
	double sine;
	double angle;

	public Twist() { this(0); 		//{{INIT_CONTROLS
		//}}
}	

	public Twist(double angle)
	{
		this.angle = angle;
		this.cosine = Math.cos(Math.PI * angle / 180.0);
		this.sine = Math.sin(Math.PI * angle / 180.0);
	}	

	public Twist negative() 
	{
		return new Twist(-angle);
	}
 	//{{DECLARE_CONTROLS
	//}}
}
