/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

/**
 * Poster is a simple panel
 */

import java.awt.*;

public class Poster extends Component3d
{
	public Poster(Vertex p1, Vertex p2)
	{
		this(p1, p2, new Texture(Color.blue));
	}


	public Poster(Vertex p1in, Vertex p2in, Texture texture)
	{
		super();

		Vertex p1 = new Vertex(
					(p1in.x > p2in.x) ? p1in.x : p2in.x,
					(p1in.y > p2in.y) ? p1in.y : p2in.y,
					(p1in.z > p2in.z) ? p1in.z : p2in.z
				);

		Vertex p2 = new Vertex(
					(p1in.x < p2in.x) ? p1in.x : p2in.x,
					(p1in.y < p2in.y) ? p1in.y : p2in.y,
					(p1in.z < p2in.z) ? p1in.z : p2in.z
				);

		Vertex a = new Vertex(p1.x, p1.y, p1.z, 0, 0);
		Vertex b = new Vertex(p1.x, p2.y, p2.z, texture.tWidth, texture.tHeight);
		add(new Square(a, b, texture));

	}

   // added

    public Poster()
    {
     this(new Vertex(), new Vertex());
    }
    
    
    public Poster(Texture texture)
    {
     this(new Vertex(), new Vertex(), texture);
    }


}
