/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

/**
   The Viewpoint class defines the position of the viewer.
   Il est compos d'un Vertex (3 coo) et d'une orientation
   (3 angle et 3 twist)
 */

import java.awt.*;

public class Viewpoint
{
	Vertex from;
	Orient o1;
	Component parent;

	public Viewpoint() { this(new Vertex(), new Orient()); 		//{{INIT_CONTROLS
		//}}
}

	public Viewpoint(Vertex from) {	this(from, new Orient()); }

	public Viewpoint(Vertex from, Orient o1) 
	{
	 this.from = new Vertex(from);
	 this.o1 = new Orient(o1);
	}

	//public void repaint() {	}

	public void changeOrient(int pitch, int yaw, int roll) 
	{
		o1 = new Orient(o1.pitchAngle + pitch, o1.yawAngle + yaw, o1.rollAngle + roll);
	}

   public void reverse(double d) {	thrust(-d);	}

   public void thrust(double d) 
	{
	 if (parent != null)
	  synchronized(parent) 
	  {
		from.z = from.z + (d * o1.pitch.cosine * o1.yaw.cosine);
		from.x = from.x + (d * o1.yaw.sine);
		//repaint();
	  }
	}

  public void up(double d) { from.y = from.y + d;	}
  public void turnright(double d) { changeOrient (0, (int)d, 0); }
	//{{DECLARE_CONTROLS
	//}}
}
