/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package comgr;

import java.awt.*;
import java.awt.image.*;

/**
   Cette classe traite des images en tant que
   tableaux de pixels
*/


public class VirtualImage extends Component
{
  static Toolkit toolkit  = Toolkit.getDefaultToolkit();
  Image image = null;
  int width;
  int height;

  /**
     Load an image
  */
  public boolean load(Image img)
  {
    image = img;
    
    MediaTracker tracker = new MediaTracker(this);
    tracker.addImage(image, 0);
    try
     {
      tracker.waitForAll();
      width = image.getWidth(null);
      height = image.getHeight(null);
      return true;
     }
    catch(InterruptedException e) { }

    return false;
  }

  /**
     Prend les pixels de l'image
  */

  public int[] getPixels()
  {
    return getPixels(image, width, height);
  }

  /**
     Sur une image sur disque
  */   
  static public int[] getPixels(Image image)
  {
    return getPixels(image, image.getWidth(null),  image.getHeight(null));
  }
  
  static public int[] getPixels(Image image, int w, int h)
  {

    if(image == null)
    {
     System.out.println("VirtualImage - Image null");
     return null;
    }

    int[] pixels = new int[w * h];
    PixelGrabber pg = new PixelGrabber(image, 0, 0, w, h, pixels, 0, w);
    try
    {
     pg.grabPixels();
    }
    catch(InterruptedException i) { }

    if ((pg.getStatus() & ImageObserver.ABORT) != 0)
	   {
	    System.out.println("Error, image fetch stopped");
      return null;
	   }

    return pixels;
 }



 /**
    Cre une image
 */   
 static public Image getImage(int pixels[], int width, int height)
 {
  MemoryImageSource mis = new MemoryImageSource(
    width, height, pixels, 0,  width);

  return toolkit.createImage(mis);

 }   

}
