/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.util.Vector;
import java.awt.event.MouseEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.IllegalArgumentException;


public class CardPanel extends Panel
{

 Vector compList = new Vector();
 private Component userPanel = null;
 int old = -1;
 CardLayout cards;

 public CardPanel()
 {
   super();
   cards = new CardLayout();
   super.setLayout(cards);
 }


 public java.awt.Component add(Component c)
 {
   super.add(c, "");
   c.setVisible(false);
   compList.addElement((Object) c);
   cards.addLayoutComponent(c, c.getName());
   cards.layoutContainer(this);
   return c;
 }

 public synchronized void addNotify()
 {
    super.addNotify();
 }

 public synchronized void removeNotify()
 {
    super.removeNotify();
 }



 public int getTab() { return old; }

 public void first() { select(0); }


 public void select(int no)
 {
   if(no < 0)
   {
    no = 0;
   }

   if(no >= compList.size())
   {
    System.out.println("Error in CardPanel: " + no + " > " + compList.size());
    return;
   }

   Component c;

   if(old != -1)
   {
     c = (Component) compList.elementAt(old);
     c.setVisible(false);
   }
   c = (Component) compList.elementAt(no);
   c.setVisible(true);
   c.requestFocus();
   cards.show(this, c.getName());
   userPanel = c;
   validate();
   repaint();

   old = no;
 }

 public Dimension getPreferredSize()
 {
     Dimension p = getSize();
     Dimension m = getMinimumSize();
     return new Dimension(Math.max(p.width, m.width), Math.max(p.height, m.height));
 }

 public Dimension getMinimumSize()
 {
     return new Dimension(20, 40);
 }


 public void doLayout()
 {
         Rectangle r = getBounds();

         if (userPanel != null)
         {
           userPanel.setBounds(0, 0, r.width, r.height);
           userPanel.invalidate();
           userPanel.validate();
           if (userPanel instanceof Canvas || userPanel instanceof Panel)
           {
              userPanel.repaint();
           }
           else
           {
              repaint();
           }
         }
 }





}
