/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import common.*;

/**
 * DBarSpacer component.
 * This component is used to space items in a Bar.
 */

public class DBarSpacer extends Component
{
	/** The size  in pixels */
	protected int space;
    protected int height;

    /** Create a DBarSpacer  default 10 x 10 pixels */
    public DBarSpacer(int w, int h)
    {
    	space = w;
    	height = h;
    }

    public DBarSpacer(int w) { this(w, 10); }

    public DBarSpacer() { this(10, 10); }



    /** Sets the size of the space the spacer will occupy in pixels */
    public void setSpace(int value) { space = value; }
    public void setSize(int w, int h)
    {
      super.setSize(w, h);
      space = w;
      height = h;
    }

    /** Gets the size of the space the spacer will occupy in pixels */
    public int getSpace() { return space;}

    /** the recommended dimensions to properly display this component */
    public synchronized Dimension getPreferredSize()
    {
       return new Dimension(space, height);
    }

    /** the minimum dimensions to properly display this component*/
    public synchronized Dimension getMinimumSize() { return getPreferredSize();}


//    public void update(Graphics g) { paint(g); }
/*
    public void paint(Graphics g)
    {
       ;
       // Rien, prend de la place et fixe la taille du container
    }
 */
}

