/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import common.*;

/** Tool Bar Separator */

public class DSeparator extends Canvas
{

	/** The size in pixels */

	protected int space;
	protected int height;

    Color lineLight;
    Color lineDark;

    /** Create a DSeparator */

    public DSeparator() { this(8, 16); }
    public DSeparator(int w, int h)
    {
        space = w; height = h;
    }


    /** Sets the size of the space the spacer will occupy in pixels */
    public void setSpace(int value) { space = value;}

    /** Gets the size of the space the spacer will occupy in pixels  */
    public int getSpace() { return space; }

    public void setSize(int w, int h)
    {
        super.setSize(w, h);
        space = w;
        height = h;
    }

    public void setBounds(int x, int y, int w, int h)
    {
        super.setBounds(x, y, w, h);
        space = w;
        height = h;
    }


    /** Returns the recommended dimensions to properly display */
    public synchronized Dimension getPreferredSize()
    {
        return new Dimension(space, height);
    }


    /** Returns the minimum dimensions to properly display this component */
    public synchronized Dimension getMinimumSize() { return getPreferredSize();}

	/** Is the specified space size valid? */
	public boolean isValidSpace(int spaceSize) { return (spaceSize >= 0); }


//	public void update(Graphics g) { paint(g);	}

	public void paint(Graphics g)
	{
      if(!isShowing()) return;

      java.awt.Dimension mySize = getSize();
      int w = mySize.width;
      int h = mySize.height;
	  int x = w / 2;
	  int y = 0;

      lineLight = getBackground().brighter();
      lineDark  = getBackground().darker();

	  g.setColor(lineDark);
	  g.drawLine(x, y, x , y + h - 1);
	  g.setColor(lineLight);
	  g.drawLine(x + 1, y, x + 1, y + h -  1);

	}

}

