/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import common.*;


public class FindDialog extends DDialog implements ActionListener, KeyListener
{
	FindReplace FR;

	DCheckbox checkCase;
	java.awt.TextField inputText;
	java.awt.Button buttonFind;
	java.awt.Button buttonCancel;
	DLabel labelResult;

	public FindDialog(Frame parent, boolean modal)
	{
	 super(parent, modal);
	 setSize(400, 112);

     DLabel labelFind = new DLabel("Find What?");
	 labelFind.setBounds(getInsets().left +  12, getInsets().top + 10, 96, 20);
	 panel.add(labelFind);

	 inputText = new java.awt.TextField();
	 inputText.setBounds(getInsets().left +  16,getInsets().top +  34, 270, 24);
	 inputText.addKeyListener(this);
	 panel.add(inputText);

	 buttonFind = new java.awt.Button("Find");
	 buttonFind.setBounds(getInsets().left + 320, getInsets().top + 34, 72, 24);
	 buttonFind.setBackground(getBackground());
	 buttonFind.addActionListener(this);
	 panel.add(buttonFind);

	 buttonCancel = new java.awt.Button("Close");
	 buttonCancel.setBounds(getInsets().left + 320, getInsets().top + 66, 73, 24);
	 buttonCancel.setBackground(getBackground());
	 buttonCancel.addActionListener(this);
	 panel.add(buttonCancel);

	 checkCase = new DCheckbox("Match case");
  	 checkCase.setBounds(getInsets().left + 16,getInsets().top +  71, 112, 20);
	 panel.add(checkCase);

	 labelResult = new DLabel("", DLabel.BEVEL_NONE, DLabel.ALIGN_CENTER);
	 labelResult.setBounds(getInsets().left + 132, getInsets().top + 70, 184, 20);
	 panel.add(labelResult);

}


 public FindDialog(Frame parent, String title, boolean modal, FindReplace fr)
  {
 	this(parent, modal);
	setTitle(title);
	FR = fr;
	inputText.setText(FR.getFind());
	checkCase.setState(FR.isCase());
  }

 public void actionPerformed(java.awt.event.ActionEvent event)
  {
    Object object = event.getSource();

	if (object == buttonFind)			find();
        else if (object == buttonCancel)        setVisible(false);
  }

   /* Recherche */
   void find()
	{
     FR.setFind(inputText.getText().trim());
     FR.setCase(checkCase.getState());
     FR.setIndexToFind();

   	 FindReplaceEngine fre = new FindReplaceEngine(FR);
     fre.FindIt();

     if(FR.isFoundIt())
       labelResult.setText("Found " + FR.getOccur());
     else
     {
       labelResult.setText("End of File - " + FR.getOccur() + " found");
       this.getToolkit().beep();
     }
     labelResult.setVisible(true);
	}


	public void setString(String str) { inputText.setText(str); }

	public String getString() {  return inputText.getText(); }


    /* Clavier */
    public void keyTyped(KeyEvent event) { }
    public void keyReleased(KeyEvent event) { }
	public void keyPressed(java.awt.event.KeyEvent event)
	   {

        if(event.isControlDown() || event.isAltDown()) return;

        switch(event.getKeyCode())
         {
       	   case KeyEvent.VK_ENTER:  find(); break;
       	   case KeyEvent.VK_F3:     find(); break;
           case KeyEvent.VK_ESCAPE: setVisible(false); break;
       	   default:
           /*
                char c = event.getKeyChar();
                char newc = new Character(c).charValue();
       	        if (c != newc) event.consume();
           	    event.setKeyChar(newc);
           */
       	        break;
       	 }
      }


}
