/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import common.*;

public class HtmlList
{
  int width;
  int height;

  FileWriter fw;
  BufferedWriter bw;

  static String g = "\"";

  public String htmlFile = ""; // le fichier html avec chemin
  public String htmlName = ""; // le fichier html
  public String htmlDir  = "";

  String paths[];
  String names[];
  int count;


  /* Constructeur */


  public HtmlList(String dir, String liste[])
  {
    count = liste.length;

    names = liste;
    paths = new String[count];

    for(int i = 0; i < count; i++)
    {
      paths[i] = Path.merge(dir, liste[i]);
    }

  		//{{INIT_CONTROLS
		//}}
}


 public HtmlList(DirBox d, String dir)
 {
   count = 0;
   int siz = d.items.size();

   ListItem li;
   VectorString vn = new VectorString();
   VectorString vp = new VectorString();

   for (int i = 0; i < siz; i++)
    {
     li = (ListItem) d.items.elementAt(i);

     String name = li.sText;
     vn.addElement(name);
     vp.addElement(Path.merge(dir, name));
     count++;
   }

   if(count > 0)
   {
    names = new String[count]; vn.copyInto(names);
    paths = new String[count]; vp.copyInto(paths);
   }
 }




 /** Dfinit le fichier gnr */
 public void setFile(String dir, String name)
 {
   htmlFile = Path.merge(dir, name);
   htmlDir  = dir;
   htmlName = name;
 }



 /**
   Remplace le nom dans names[]
   si c'est un html et si il y a un titre
 */

 public boolean foundTitle(int index)
 {
   String name = names[index];
   paths[index] = names[index];

   int l = name.lastIndexOf(".");
   if(l != -1)
   {
    String ext = name.substring(l + 1);

    /*
    if(ext.equalsIgnoreCase("htm") ||
       ext.equalsIgnoreCase("html") ||
       ext.equalsIgnoreCase("php") ||
       ext.equalsIgnoreCase("php3") ||
       ext.equalsIgnoreCase("php4") ||
       ext.equalsIgnoreCase("asp"))
     */
     {
      // ouvre, cherche , remplace
      name = name.substring(0, l);
      String maj = name.substring(0, 1).toUpperCase();
      if(name.length() < 2) names[index] = maj;
      else
       names[index] = maj + name.substring(1).toLowerCase();
      return true;
     }

   }

   return false;
 }




 private void put(String s)
 {
   try
   {
    bw.write(s, 0, s.length());
    bw.newLine();
   }
   catch(IOException i) { System.out.println("Enable to write " + s); }
 }


 public int createHtml()
 {

   //System.out.println("titre " + htmlFile);

   try
   {
     fw = new FileWriter(htmlFile);
     bw = new BufferedWriter(fw);
   }
   catch(IOException i) { System.out.println("Enable to make " + htmlFile); }


   put("<HTML>");
   put("<HEAD>");
   put("<TITLE> Generated by Advanced Explorer - www.scriptol.com </TITLE>");

   put("<STYLE TYPE=" + g + "text/css" + g + " MEDIA=screen >");
   put("<!--");
   put(" BODY { font-family: " + g + "Courrier New" + g + ", Courrier, mono, Monospaced, Arial  }");
   put("-->");
   put("</STYLE>");

   put("</HEAD>");

   if(Preferences.pageColor.equalsIgnoreCase("None"))
    put("<BODY>");
   else
    put("<BODY bgcolor=" + Preferences.pageColor + ">");

   put("<UL>");

   for(int i = 0; i < count; i++)
   {

    foundTitle(i);
    //System.out.println(i + ") title " + names[i]);

    put("<LI><A HREF=" + g + paths[i] + g +
        ">" + names[i] + "</A>");
   }
   put("</UL>");
   put("</BODY>");
   put("</HTML>");

   try { bw.close(); }
   catch(IOException ic) { ic.printStackTrace(); }

   return count;
 }
	//{{DECLARE_CONTROLS
	//}}
}
