/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.io.*;
import java.awt.event.ActionListener;
import common.*;

/**
   Boite de dialogue pour
   rechercher un fichier
*/

public class LocateDialog extends DDialog implements ActionListener
{
    LocateEngine fre = null;
    List textLocate = null;;

    boolean achieved = false; // recherche lance, termine


    public String dirfound = null;
    public String filefound = null;

    public final static int CANCEL = 0;
    public final static int GO = 1;
    public final static int OPEN = 2;
    public int result;

    String CurDrive = "";


    DBPanel panelControl;
    TextField inputFilename;
    Button buttonCancel;
    Button buttonSearch;
    Label labelFilename;
    Button buttonGo;
    Button buttonOpen;
    Label labelResult;
    Panel panelText;
    Label labelDir;

    SWThread searchThread = null;

    /**
       gopath pour avoir le bouton "Go path"
       par dfaut, sans
       avec quand on donne un prvious
    */

    public LocateDialog(Frame parent, boolean gopath)
    {
        super(parent);
        result = CANCEL;

        int textSize = 30;
        if(OS.isWindows()) textSize = 24;

	setLayout(new BorderLayout(0,0));
	setBounds(80,80, getInsets().left + getInsets().right + 556,getInsets().top + getInsets().bottom + 360);

	panelControl = new DBPanel(DBPanel.BEVEL_RAISED);
	panelControl.setLayout(null);
	panelControl.setBounds(getInsets().left + 0,getInsets().top + 0,556,152);
	panelControl.setFont(new Font("Dialog", Font.PLAIN, 14));
	panelControl.setBackground(getBackground());
	add("North", panelControl);

	buttonSearch = new java.awt.Button("Search");
	buttonSearch.setBounds(8, 8, 94,32);
	buttonSearch.setBackground(getBackground());
	buttonSearch.addActionListener(this);
	panelControl.add(buttonSearch);

	buttonOpen = new java.awt.Button("Open");
	buttonOpen.setBounds(106, 8, 96, 32);
	buttonOpen.setBackground(getBackground());
        buttonOpen.setEnabled(false);
	buttonOpen.addActionListener(this);
	panelControl.add(buttonOpen);

	buttonGo = new java.awt.Button("Go to path");
	buttonGo.setBounds(206, 8,112,32);
	buttonGo.setBackground(getBackground());
        buttonGo.setEnabled(false);
	buttonGo.addActionListener(this);
	if(gopath) panelControl.add(buttonGo);

	buttonCancel = new java.awt.Button("Cancel");
	buttonCancel.setBounds(446, 8,94, 32);
	buttonCancel.setBackground(getBackground());
	buttonCancel.addActionListener(this);
	panelControl.add(buttonCancel);

        if(OS.isWindows())
 	  labelFilename = new Label("File to locate:  filename  or  drive:filename");
        else
          labelFilename = new Label("File to locate:  filename");
	labelFilename.setBounds(8, 60,312,16);
	panelControl.add(labelFilename);

	inputFilename = new java.awt.TextField();
	inputFilename.setBounds(8, 82, 300, textSize);
	panelControl.add(inputFilename);

	labelResult = new Label();
	labelResult.setBounds(340, 83, 180, textSize - 2);
        labelResult.setBackground(Color.black);
        labelResult.setForeground(Color.green);
        labelResult.setAlignment(Label.CENTER);
	panelControl.add(labelResult);

        labelDir = new Label("Searching directory...");
        labelDir.setBounds(8, 116, 516, textSize - 2);
        panelControl.add(labelDir);


	panelText = new java.awt.Panel();
	panelText.setLayout(new GridLayout(1,0,0,0));
	panelText.setBounds(getInsets().left + 0,getInsets().top + 10,556,260);
	add("Center", panelText);

        textLocate = new List();
        textLocate.setBackground(getBackground().brighter());
        textLocate.setForeground(Color.black);
        textLocate.setFont(new Font("Courier", Font.PLAIN, 14));
        textLocate.setMultipleMode(false);
	panelText.add(textLocate);

	setTitle(" Locate a file or directory");

        if(OS.isWindows())
          CurDrive = "c:";
        else
          CurDrive = "";

}

    public LocateDialog(Frame parent)
    {
      this(parent, false);
    }


    public LocateDialog(Frame parent, String previous)
    {
       this(parent, true);
       inputFilename.setText(previous);
    }


    public void setTextStyle(Style s)
    {
     textLocate.setFont(s.font);
     textLocate.setBackground(s.background);
     textLocate.setForeground(s.foreground);
    }


    public class SWThread extends Thread
    {
       SWThread() { }
       public void run() { findAction(); }
    }



  public void actionPerformed(java.awt.event.ActionEvent event)
  {
    Object object = event.getSource();
    if (object == buttonSearch)
    {
      searchThread = new SWThread();
      setThread(searchThread);
      searchThread.start();
    }
    else
    if (object == buttonCancel)
    {
      if(searchThread != null)
        {
           searchThread.interrupt();
           searchThread = null;
           if(!achieved)
           {
              setResult("Stopped");
              return;
           }
        }


      hide();
      dispose();
      return;
    }
    else if(object == buttonGo) Action(GO);
    else if(object == buttonOpen) Action(OPEN);
    else if(object == fre) // un seul message, action non teste
     {
        textLocate.select(0);
        buttonGo.setEnabled(true);
        buttonOpen.setEnabled(true);
     }
  }


    // Lecture/Ecriture des variables

    public void setCurDrive(String drive) { CurDrive = drive; }
    public void setInput(String previous) { inputFilename.setText(previous);}
    public void setResult(String str)   { labelResult.setText(str); }
    public String getInput() { return inputFilename.getText(); }

    // Lancement de la recherche
    public void findAction()
    {
        // Cre un engin avec nom et listbox
        String textToLocate = inputFilename.getText().trim();
        String basepath = CurDrive;
        int l;

        // Prendre disk
        if(textToLocate.length() == 0) return;
        this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        int dskdelim = textToLocate.indexOf(":");
        if(dskdelim != -1)
        {
          l = textToLocate.length();
          basepath = textToLocate.substring(0, dskdelim + 1);
          textToLocate = textToLocate.substring(dskdelim + 1, l);
        }

        inputFilename.setText(basepath + textToLocate);

        setResult("Searching...");
        textLocate.removeAll();

        fre = new LocateEngine(basepath, textToLocate, textLocate, true);
        fre.addActionListener(this);
        fre.setOccur(0);
        fre.setLabel(labelDir);
        fre.FindIt();   // Commande  l'engin la recherche

        int num = fre.getOccur();
        if(num > 0)
         {
          setResult("Found " + num);
          buttonGo.setEnabled(true);
          buttonOpen.setEnabled(true);
         }
        else
          setResult("No found");

        achieved = true;
        this.setCursor(Cursor.getDefaultCursor());
        Tool.beep();
      }


   // Select in list and add to found

   void Action(int action)
   {
       if(searchThread != null)
        {
         searchThread.interrupt();
         searchThread = null;
        }

       int m = textLocate.getItemCount();
       if(m < 1)  return;
       if(m == 1) textLocate.select(0);

       String name = textLocate.getSelectedItem();
       //System.out.println(name);
       if(name == null) return;

       dirfound  = Path.splitPath(name);
       filefound = Path.splitFile(name);
       result = action;


       hide();
       dispose();
     }

}
