/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import common.*;

public class OutlineH
{
  int width;
  int height;

  FileWriter fw;
  BufferedWriter bw;

  static String g = "\"";

  String htmlFile = "generated.htm"; // le fichier html avec chemin
  String htmlName = "generated.htm"; // le fichier html
  String htmlDir  = "";

  String path;
  String name;
  VectorString header;
  VectorString lines;
  VectorString body;
  VectorString titles;
  int count;

  String codeTitle;

  /* Constructeur */


  public OutlineH(String dir, String textfile)
  {
     name = textfile;
     path = Path.merge(dir, textfile);
  }



 /** Dfinit le fichier gnr */
 public void setFile(String dir, String name)
 {
   htmlFile = Path.merge(dir, name);
   htmlDir  = dir;
   htmlName = name;
 }

  public int load()
  {
   int count = 0;

   lines = new VectorString(1024, 128);

   try
   {
     BufferedReader br = new BufferedReader(new FileReader(path));
     String s;
     do
      {
       s = br.readLine();
       if(s != null)
        {
          lines.addElement(s);
          count++;
        }
     } while(s != null);


     br.close();
   } catch(IOException e) { System.out.println("Enable to read " + path); }

   return count;
 }




 private void put(String s)
 {
   try
   {
    bw.write(s, 0, s.length());
    bw.newLine();
   }
   catch(IOException i) { System.out.println("Enable to write " + s); }
 }


 int no; // numro de titre
 boolean fermeture = false;


 private void parseLine(int index)
 {
   String s = lines.elementAt(index);

   if(s.length() > 3)
    if(Character.isSpaceChar(s.charAt(2)))
    {

    if(s.substring(0, 1).equalsIgnoreCase("h"))
     if(Character.isDigit(s.charAt(1)))
     {
      int indent = Integer.parseInt(s.substring(1, 2));

      codeTitle = s.substring(0, 2); // prendre avant suppression
      s = s.substring(3);

      // titre
      if(indent == 0)
      {
        header.addElement("<center>" + s + "</center>");
        return;
      }

      String sIndent = "";

      for(int i = 0; i < indent; i++)
      sIndent += "&nbsp;";

      String name = "title" + no++;

      String ref =
      sIndent + "<a href=" + g + "#" + name + g + ">"  +
      "<font color=green>" + s + "</font>" + "</a>";

      titles.addElement(ref);

      if(fermeture) { body.addElement("</pre>"); }

      body.addElement(
      "<" + codeTitle + "><a name=" + g + name + g + "></a>");

      s = s + "</" + codeTitle + "> <pre>";

      fermeture = true;
    }
   }

   body.addElement(s);
 }


 private void putHeader(int index)
 {
   put(header.elementAt(index));
   count++;
 }


 private void putTitles(int index)
 {
   put(titles.elementAt(index) + " <br>");
   count++;
 }

 private void putBody(int index)
 {
   put(body.elementAt(index));
   count++;
 }




 public int createHtml()
 {

   if(load() == 0) return 0;

   header = new VectorString();
   titles = new VectorString(count / 10, 32);
   body   = new VectorString(count * 9 / 10, 32);

   try
   {
     fw = new FileWriter(htmlFile);
     bw = new BufferedWriter(fw);
   }
   catch(IOException i) { System.out.println("Enable to make " + htmlFile); }

   no = 0;


   for(int i = 0; i < lines.size(); i++)
    parseLine(i);

   put("<HTML>");
   put("<HEAD>");
   put("<TITLE> Generated by Advanced Explorer - www.geocities.com/dgsureau </TITLE>");

   put("<STYLE TYPE=" + g + "text/css" + g + " MEDIA=screen >");
   put("<!--");
   put(" BODY { font-family: " + g + "Courrier New" + g + ", Courrier, mono, Monospaced, Arial  }");
   put(" TABLE { font-family: " + g + "Courrier New" + g + ", Courrier, mono, Monospaced, Arial  }");
   put(" H3 { font-size: small; color: green }");
   put(" H4 { font-size: small; color: green }");
   put(" H5 { font-size: small; color: green }");
   put(" H6 { font-size: small; color: green }");
   put(" PRE { font-family: " + g + "Courrier New" + g + ", Courrier, mono, Monospaced, Arial  }");

   put("-->");
   put("</STYLE>");

   put("</HEAD>");

   if(Preferences.pageColor.equalsIgnoreCase("None"))
    put("<BODY>");
   else
    put("<BODY bgcolor=" + Preferences.pageColor + ">");

   for(int h = 0; h < header.size(); h++) putHeader(h);

   put("<br><hr>");
   put("<TABLE align="+g+"center"+g+" width=" + g + "400" + g + ">");
   put("<TR>");
   put("<TD>");

   for(int s = 0; s < titles.size(); s++) putTitles(s);

   put("</TD>");
   put("</TR>");
   put("</TABLE>");
   put("<HR><br>");

   for(int b = 0; b < body.size(); b++) putBody(b);

   if(fermeture) put("</PRE>");
   put("</BODY>");
   put("</HTML>");

   try { bw.close(); }
   catch(IOException ic) { ic.printStackTrace(); }

   return count;
 }
}
