/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import common.*;

public class PanelOutline extends PanelGenerator
{

  public PanelOutline(Frame f)
   {
    super(f);
    setTitle("OUTLINED MANUAL");
    setAction("Make an outlined manual from a text file");
    
    DBPanel options = new DBPanel(Bevel.LINE);
    options.setLabel("Options");
    add(options, BorderLayout.CENTER);
   }


 public void selMessage()
 {
   dispTip("Select a single file, please..."); 
 }  

 public boolean select(DirManager dirman)
 {
  String fic = dirman.getSelected();
  if (fic == null) return false;
  if (dirman.countItems() == 1)
  {
    selMessage(); return false;
  }  
  
  if (new File(dirman.getDir(), fic).isDirectory())
  {
    selMessage(); return false;
  }  
  
  String node = Path.getNode(fic);
  
  setFilename(node + ".html");  
  return true;
 }    
 
 public void init(DirManager s, DirManager t, boolean b)
 {
  super.init(s, t, b);
  
  if (s.countSelected() > 1) selMessage();
  return;
 }   
}

