/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import common.*;

public class PanelThumbnail extends PanelGenerator
{

  TSpinner spinnerW;
  TSpinner spinnerH;

  DCheckbox checkBorder;
  DCheckbox checkName;
  DCheckbox checkSize;
  DCheckbox checkType;


  public PanelThumbnail(Frame f)
   {
    super(f);

    //setLayout(null);
    setTitle("THUMBNAIL");
    setAction("Make a thumbnail of selected files");

    DBPanel options = new DBPanel(Bevel.LINE);
    options.setLabel("Options");
    add(options, BorderLayout.CENTER);

    Label sl1 = new Label("Image width");
    sl1.setBounds(24, 22, 92, 20);
    options.add(sl1);

    spinnerW = new TSpinner(Preferences.ThumbWidth, 16, 256);
    spinnerW.setBounds(118, 22, 72, 20);
	spinnerW.addActionListener(this);
    options.add(spinnerW);

    Label sl2 = new Label("Cell width");
    sl2.setBounds(220, 22, 74, 20);
    options.add(sl2);

    spinnerH = new TSpinner(Preferences.ThumbCell, 16, 256);
    spinnerH.setBounds(304, 22, 72, 20);
	spinnerH.addActionListener(this);
    options.add(spinnerH);

	checkName = new DCheckbox("Display the names", Preferences.ThumbName);
	checkName.setBounds(20, 64 , 156, 22);
	checkName.addItemListener(this);
    options.add(checkName);

   	checkBorder = new DCheckbox("Draw a border", Preferences.ThumbBorder);
	checkBorder.setBounds(212, 64, 132, 22);
	checkBorder.addItemListener(this);
	options.add(checkBorder);

	checkSize = new DCheckbox("Display the sizes", Preferences.ThumbSize);
	checkSize.setBounds(20, 96, 140, 22);
	checkSize.addItemListener(this);
	options.add(checkSize);

	checkType = new DCheckbox("Display the types", Preferences.ThumbType);
	checkType.setBounds(212, 96, 140, 22);
	checkType.addItemListener(this);
	options.add(checkType);

   }

  String graph =  ".png.bmp.gif.jpg." ;

  public void select(DirManager source)
  {
    if (source.isSelected()) return;

    int number = 0;
    String[] list = source.getFiles();

    for(int i = 0; i < list.length; i++)
    {
      String fic = list[i];
      if (fic != null)
      {
       String ext = Path.getExtension(fic).toLowerCase();
       if (source.inside(graph, ext))
       {
        source.selectCtrl(fic);
        number++;
       }
      }
    }
    dispTip(number + " graphic files with valid format");
  }

  public void actionPerformed(java.awt.event.ActionEvent event)
	{
	 Object object = event.getSource();

      if(object == spinnerW)
         Preferences.ThumbWidth = spinnerW.current;
      else if(object == spinnerH)
         Preferences.ThumbCell = spinnerH.current;
      else super.actionPerformed(event);
   }



    public void itemStateChanged(java.awt.event.ItemEvent event)
	 {
	   Object object = event.getSource();

		//String strevent = (String) event.getItem();

	   if (object == checkBorder)
		   Preferences.ThumbBorder = checkBorder.getState();
	   else if (object == checkName)
		   Preferences.ThumbName = checkName.getState();
	   else if (object == checkSize)
		   Preferences.ThumbSize = checkSize.getState();
	   else if (object == checkType)
		   Preferences.ThumbType = checkType.getState();
    }

}
