/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.io.*;
import java.awt.event.*;
import common.*;

public class SetupWindow extends DDialog implements ActionListener, ItemListener
{

    public String dirfound = null;
    public String filefound = null;
    String html = null;
    String edit = null;
    String player = null;
    String painter = null;
    String helper = null;
    String reader = null;
    int counter;        // item de la liste
    int NavigatorStart;
    int NavigatorEnd;
    int EditorStart;
    int EditorEnd;
    int PlayerStart;
    int PlayerEnd;
    int PainterStart;
    int PainterEnd;
    int HelpStart;
    int HelpEnd;
    int PdfStart;
    int PdfEnd;


    boolean firstOnly = true;
    int NNumber;
    int ENumber;
    int PNumber;
    int INumber;
    int HNumber;
    int RNumber;

    SWThread searchThread = null;

	public final static int CANCEL = 0;
	public final static int GO = 1;
	public final static int OPEN = 2;
	public int result;

	Color background;
    String CurDrive = "c:";

    // Composants
    List textLocate;
    DCheckbox checkFirst;

	DBPanel panelControl;
	java.awt.Button buttonStart;
	java.awt.Button buttonCancel;
	java.awt.Button buttonAccept;

	Label labelResult;
    Label labelInfo;
	java.awt.Panel panelText;

	public SetupWindow(Frame parent)
	{
		super(parent);
        result = 0;

		//{{INIT_CONTROLS
		setLayout(new BorderLayout(0,0));
		setVisible(false);
		setSize(getInsets().left + getInsets().right + 556,getInsets().top + getInsets().bottom + 360);
		//}}

        setResizable(true);

        background = parent.getBackground();
        setBackground(background);

		panelControl = new DBPanel(DBPanel.BEVEL_RAISED);
		panelControl.setLayout(null);
		panelControl.setBounds(getInsets().left + 0,getInsets().top + 0,556,112);
        panelControl.setBackground(background);
		panelControl.setFont(new Font("Dialog", Font.PLAIN, 14));
		add(panelControl, BorderLayout.NORTH);

		buttonStart = new java.awt.Button("Start");
		buttonStart.setBounds(16, 8,94, 32);
        buttonStart.setBackground(background);
		buttonStart.addActionListener(this);
		panelControl.add(buttonStart);

		buttonAccept = new java.awt.Button("Accept");
		buttonAccept.setBounds(128, 8,94, 32);
        buttonAccept.setBackground(background);
		buttonAccept.addActionListener(this);
//        buttonAccept.setEnabled(false);
		panelControl.add(buttonAccept);

		buttonCancel = new java.awt.Button("Cancel");
		buttonCancel.setBounds(438, 8, 94, 32);
        buttonCancel.setBackground(background);
		buttonCancel.addActionListener(this);
		panelControl.add(buttonCancel);

		labelInfo = new Label("Remove disks from each removable drive unit and click on Start");
		labelInfo.setBounds(16, 44, 516, 22);
		panelControl.add(labelInfo);

        checkFirst = new DCheckbox("First found only", true);
        checkFirst.setBounds(16, 74, 128, 22);
        checkFirst.setBackground(background);
        panelControl.add(checkFirst);

		labelResult = new Label();
		labelResult.setBounds(168, 74, 364, 22);
        labelResult.setBackground(Color.black);
        labelResult.setForeground(Color.green);
        labelResult.setAlignment(Label.CENTER);
		panelControl.add(labelResult);

		panelText = new java.awt.Panel();
		panelText.setLayout(new GridLayout(1,0,0,0));
		panelText.setBounds(0,2, 556, 292);
		add(panelText, BorderLayout.CENTER);

	    textLocate = new List();
	    textLocate.setBackground(background.brighter());
	    textLocate.setForeground(Color.black);
	    textLocate.setFont(new Font("Courier", Font.PLAIN, 16));
        textLocate.setMultipleMode(true);
		panelText.add(textLocate);

		setTitle(" Automatic paths setting");

		checkFirst.addItemListener(this);

}

    public void setTextStyle(Style s)
    {
     textLocate.setFont(s.font);
     textLocate.setBackground(s.background);
     textLocate.setForeground(s.foreground);
    }

    public synchronized void setVisible(boolean b)
    {
       super.setVisible(b);
       textLocate.setVisible(b);
    }


    class SWThread extends Thread implements Runnable
    {
       SWThread() { }
       public void run() { startFind(); }
    }



    public void actionPerformed(java.awt.event.ActionEvent e)
	 {
	   Object object = e.getSource();
	   if (object == buttonCancel)
        {
          if(searchThread != null) searchThread.destroy();
          searchThread = null;
          setVisible(false);
          return;
        }
	   else if (object == buttonStart)
        {
          searchThread = new SWThread();
          setThread(searchThread); // DDialog
          searchThread.start();
        }
       else if(object == buttonAccept)
         {
          if(searchThread != null) searchThread.destroy();
          searchThread = null;
          acceptThem();
          setVisible(false);
          return;
         }
	}

	 public void itemStateChanged(java.awt.event.ItemEvent event)
	  {
		Object object = event.getSource();
		if (object == checkFirst) firstOnly = checkFirst.getState();
      }


    // Lecture/Ecriture des variables
    void setResult(String str)   { labelResult.setText(str); }

    void driveIdent(boolean removable)
    {
       if(OS.isWindows())
       {
        String letters = "acdefghijklmnopqrstuvwxyz";

        int i = 0;
        boolean found = true;
        while((i < letters.length()) && found)
        {
         char c = letters.charAt(i);
         String drive = c + ":";
         File test = new File(drive + File.separatorChar);
         if(test.exists())
         {
           textLocate.add("Drive " + c + " found.");
           Windows.DiskBase.addElement(drive);
           Windows.DiskType.addElement(removable);
           counter++;
         }
         else
         {
            if(i > 5) found = false;
         }
         i++;
        }
       }
    }

    void startFind()
     {

       Preferences.configLoad();

       textLocate.removeAll();
       Windows.clearBase();
       counter = 0;
       NNumber = 0;
       ENumber = 0;
       PNumber = 0;
       INumber = 0;
       HNumber = 0;
       RNumber = 0;
       // Identification des drives
       labelInfo.setText("Searching, please be patient...");
       driveIdent(false);

       html = null;
       edit = null;
       player = null;
       painter = null;
       helper = null;
       reader = null;

       //int start = 0;

       // Explorateur
       setResult("Searching for a navigator...");
       NavigatorStart = textLocate.getItemCount();
       boolean nfound = false;
       NNumber = find(Preferences.navigator, Windows.DiskBase);
       if(NNumber > 0)
        {
         html = textLocate.getSelectedItem();
         nfound = true;
        }
       NavigatorEnd = textLocate.getItemCount();

       // Editeur
       setResult("Searching for an editor...");
       EditorStart = textLocate.getItemCount();
       boolean efound = false;
       ENumber = find(Preferences.editor, Windows.DiskBase);
       if(ENumber > 0)
        {
          edit = textLocate.getSelectedItem();
          efound = true;
        }

       EditorEnd = textLocate.getItemCount();


       // Painter
       setResult("Searching for a painter...");
       PainterStart = textLocate.getItemCount();
       boolean ifound = false;
       INumber = find(Preferences.painter, Windows.DiskBase);
       if(INumber > 0)
        {
          painter = textLocate.getSelectedItem();
          ifound = true;
        }
       PainterEnd = textLocate.getItemCount();

       // Player
       setResult("Searching for a multimedia player...");
       PlayerStart = textLocate.getItemCount();
       boolean pfound = false;
       PNumber = find(Preferences.player, Windows.DiskBase);
       if(PNumber > 0)
        {
          player = textLocate.getSelectedItem();
          pfound = true;
        }
       PlayerEnd = textLocate.getItemCount();


       // Help
       setResult("Searching for an help file viewer...");
       HelpStart = textLocate.getItemCount();
       boolean hfound = false;

       HNumber = find(Preferences.helper, Windows.DiskBase);
       if(HNumber > 0)
        {
          helper = textLocate.getSelectedItem();
          hfound = true;
        }
       HelpEnd = textLocate.getItemCount();


        // pdf
       setResult("Searching for a pdf/gs reader...");
       PdfStart = textLocate.getItemCount();
       boolean rfound = false;
       RNumber = find(Preferences.viewer, Windows.DiskBase);
       if(RNumber > 0)
        {
          reader = textLocate.getSelectedItem();
          rfound = true;
        }
       PdfEnd = textLocate.getItemCount();


       String res = "";
       if(nfound) res =   "Browser";  if(NNumber > 1) res += "s";
       if(efound) res += " Editor";   if(ENumber > 1) res += "s";
       if(pfound) res += " Player";   if(PNumber > 1) res += "s";
       if(ifound) res += " Painter";  if(INumber > 1) res += "s";
       if(hfound) res += " Helper";   if(HNumber > 1) res += "s";
       if(rfound) res += " Reader";   if(RNumber > 1) res += "s";

       if(!nfound && !efound && !pfound && !ifound && !hfound && !rfound) res = "Nothing";
       setResult(res + " found");

       if(NNumber > 1 || ENumber > 1 || PNumber > 1 || HNumber > 1 || RNumber > 1)
       {
        labelInfo.setText("Now insert disks, select files with Ctrl key held down and click on  Accept");
       }
       else
       {
        labelInfo.setText("Now insert disks into removable units and click on  Accept  to keep these settings");
       }
       Windows.makeMemoryBase();
       //buttonAccept.setEnabled(true);
       Tool.beep();Tool.beep();Tool.beep();
       result = NNumber + ENumber;
       return;
   }

	/**
	    recherche d'un programme
	*/


	int find(VectorString vectorToLocate, VectorString drives)
	{
      // Cre un engin avec nom et listbox
      //textToLocate = textToLocate.trim();
//      String basepath = CurDrive;
      if(vectorToLocate.size() == 0) return 0;
      String[] textToLocate = vectorToLocate.toArray();

      String basepath = "/";
      if (OS.isWindows()) basepath = "c:";

      int l;
      int foundTotal = 0;

      //System.out.println("find " + textToLocate);
      // Prendre disk

      /*
      int dskdelim = textToLocate.indexOf(":");
      if(dskdelim != -1)
       {
          l = textToLocate.length();
          basepath = textToLocate.substring(0, dskdelim + 1);
          textToLocate = textToLocate.substring(dskdelim + 1, l);
       }
      */

      int index = 0;

      textLocate.add("Searching for " + vectorToLocate.toString());

      while(index < drives.size())
       {
         LocateEngine fre = new LocateEngine(basepath, textToLocate, textLocate, false);
         fre.setOccur(0);
         fre.MultipleSearch = !firstOnly;
         fre.selectFlag = true;
         fre.FindIt();         // Commande  l'engin la recherche

         int foundNum = fre.getOccur();
         if(foundNum > 0)
         {
          //int start = textLocate.getItemCount();
          //textLocate.select(start);
          //Disp.it("isSelected=" + textLocate.isIndexSelected(start));
          //Disp.it(basepath + " start " +start + " foundnum " + foundNum);
          //Disp.it("selected " + textLocate.getSelectedItem() + " " + start + "=" + textLocate.getSelectedIndex());

          if(firstOnly) return foundNum;
          foundTotal += foundNum;
         }

         if(basepath.equalsIgnoreCase(drives.elementAt(index))) index++;
         if(index < drives.size())
          basepath = drives.elementAt(index);
       }
      // aucun drive
      return foundTotal;
	}


	// Selectionner sur la liste et mettre en found;

	void select()
	{
       if(textLocate.getItemCount() < 1)  return;

       int idx[] = textLocate.getSelectedIndexes();

       for(int i = 0; i < idx.length; i++)
       {
        int num = idx[i];
        String name = textLocate.getItem(num);
        if(name != null)
        {
         if((num < NavigatorEnd) && (num >= NavigatorStart)) html = name;
         if((num < EditorEnd) && (num >= EditorStart))       edit = name;
         if((num < PainterEnd) && (num >= PainterStart))     painter = name;
         if((num < PlayerEnd) && (num >= PlayerStart))       player = name;
         if((num < HelpEnd) && (num >= HelpStart))           helper = name;
         if((num < PdfEnd) && (num >= PdfStart))             reader = name;
        }
       }
	}


    public void acceptThem()
    {
       select();

       //System.out.println(reader);

       if(html != null)    Preferences.htmName = html;
       if(edit != null)    Preferences.edName = edit;
       if(player != null)  Preferences.playPath = player;
       if(painter != null) Preferences.paintPath = painter;
       if(helper != null)  Preferences.helpPath = helper;
       if(reader != null)  Preferences.pdfPath = reader;

       driveIdent(true);

    }



	//{{DECLARE_CONTROLS
	//}}
}
