/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.net.*;
import java.awt.image.*;

public class Splash extends Window implements MouseListener, KeyListener
{
    ImagePanel bigImage;


    public Splash(Frame parent)
    {
       super(parent);
    }

    public Splash(Frame parent, Image i)
	{
	 super(parent);
	 setLayout(new GridLayout());
 	 setVisible(false);

	 bigImage = new ImagePanel(ImagePanel.BORDER_LINE, ImagePanel.IMAGE_MAPPED);
	 bigImage.setBackground(Color.white);
     bigImage.addMouseListener(this);
     bigImage.addKeyListener(this);
	 add(bigImage);

  	 Dimension screen = getToolkit().getScreenSize();
  	 int wmax = screen.width;
  	 int hmax = screen.height;

     int w = i.getWidth(null);
     int h = i.getHeight(null);

     if (Preferences.FScale || (w > wmax) || (h > hmax))
     {
       Dimension size = getNewSize(i, w, h, wmax, hmax);
       w = size.width;
       h = size.height;
       i = i.getScaledInstance(w, h, Image.SCALE_DEFAULT);
     }

     int wd = (wmax - w) / 2;
     int hd = (hmax - h) / 2;

     setLocation(wd, hd);
	 setSize(getInsets().left + getInsets().right + w, getInsets().top + getInsets().bottom + h);

     bigImage.setImage(i);

}


  public boolean isFocusable() { return true; }

  static public Dimension getNewSize(Image model, int originW, int originH, int ivw, int ivh)
   {
     int H = ivh;
     int W = (int) ( (float) originW * (float) ivh / (float) originH);

     if(W > ivw)
      {
       W = ivw;
       H = (int) ((float) originH * (float) ivw / (float) originW);
      }

     return new Dimension(W, H);
   }


    public void update(Graphics g) { paint(g); }

	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e)
	 {
       setVisible(false);
	   dispose();
	 }

	public void mouseExited(MouseEvent e) {	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {}

    public void keyTyped(java.awt.event.KeyEvent event)
    {
      setVisible(false);
      dispose();
    }
    public void keyReleased(java.awt.event.KeyEvent event) { }
    public void keyPressed(java.awt.event.KeyEvent event) { }

}
