/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.util.*;


/**
   Cette classe dfinit 5 paramtres de style
   - fond
   - couleur texte
   - police
   - paisseur
   - taille des caractres
*/

public class Style
 {
  public String sBackground;
  public String sForeground;
  public String sFont;
  public String sStyle;
  public String sSize;

  public Font  font;
  public Color background;
  public Color foreground;

 // public Color areaBg; // couleur spciale Windows
 // public Color areaFg;

  ColorList colorlist = new ColorList();

  /**
     Constructeur
     On cre et initialise le style  la construction
     ou on dtaille les oprations
  */

  public Style()
  {

  };


  public Style(String bg, String fg, String f, int st, int si)
  {
   set(bg, fg, f, st, si);
   init();
  };



  //----- Fonctions de cration de style

  public void set(String bg, String fg, String f, int st, int si)
  {
   sBackground = bg;
   sForeground = fg;
   sFont  = f;
   sStyle = new Integer(st).toString();
   sSize  = new Integer(si).toString();
  }


  public void init()
  {
    makeFont();
    makeColors();
   // makeAreaColors();
  }

  /** Construit une fonte  partir des chaines descriptives */
  public void makeFont()
  {
    font = new Font( sFont,    // nom
                     StyleList.getStyle(sStyle),   // style gras, etc...
                     (new Integer(sSize)).intValue()); // taille
  }


  /** Affecte les variables de couleurs selon chanes descriptives */
  public void makeColors() { makeColors(true); }
  public void makeColors(boolean diff)
  {
    background = ColorList.getColor(sBackground);
    foreground = ColorList.getColor(sForeground);

    if(diff)
     if(background.equals(foreground))
     {
      System.out.println("Style error bg = fg");
      background = Color.lightGray;
      foreground = Color.black;
     }
  }

  /** Affecte les couleurs Windows */
  /*
  public void makeAreaColors()
  {
   areaBg = ColorList.getAreaColor(sBackground);
   areaFg = ColorList.getAreaColor(sForeground);
  }
  */

  /** Convertit une chaine unique en chanes descriptives */
  public void tokenize(String source)
  {
   StringTokenizer st = new StringTokenizer(source, ",");
   try
   {
    sBackground = st.nextToken();
    sForeground = st.nextToken();
    sFont       = st.nextToken();
    sStyle      = st.nextToken();
    sSize       = st.nextToken();
   }
   catch (Exception e) { }
  }

  /** Copy this style into another */

  public void copyInto(Style clone)
  {
    clone.sBackground = this.sBackground;
    clone.sForeground = this.sForeground;
    clone.sFont = this.sFont;
    clone.sStyle = this.sStyle;
    clone.sSize = this.sSize;
  }


  /** Convertit le style couleur+fonte en une chaine pour tokenizer */
  public String getString()
  {
   return sBackground + "," + sForeground + "," + sFont + "," + sStyle + "," + sSize;
  }


  public String toString()
  {
   return  font.toString() + "," + background.toString() + "," +
    foreground.toString()  +",";
//     + areaBg.toString()+ "," +  areaFg.toString();

  }


	//{{DECLARE_CONTROLS
	//}}
}
