/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

// import DLabel;
// import StyleList;
// import Preferences;
// import Style;

public class StylePanel extends Panel implements ItemListener
{
  public static final int DISPLAY_TEXT = 0;
  public static final int DISPLAY_DIR = 1;
  public static final int DISPLAY_TREE = 2;
  public static final int DISPLAY_MESSAGE = 3;

  List panelList;
  Label labelDisplay;
  Choice choiceWorkFont;
  Label labelDisplayFont;
  Choice choiceWorkSize;
  Label labelDisplaySize;

  Choice choiceWorkBg;
  Label labelDisplayBg;
  Choice choiceWorkFg;
  Label labelDisplayFg;
  Choice choiceWorkStyle;
  Label labelDisplayStyle;

  DLabel labelFontTest;

  Style WorkStyle = new Style();          // Style d'interface
  Vector styles = new Vector();
  VectorBoolean masks = new VectorBoolean();
  int maxItems;
  int lmargin = 48;
  int tmargin = 32;


  public StylePanel(int l, int t)
  {
    super();
	setLayout(null);
	setVisible(false);

    lmargin = l;
    tmargin = t;

	labelFontTest = new DLabel("Your setting", DLabel.BEVEL_LINE, DLabel.ALIGN_CENTER);
    labelFontTest.setBounds(lmargin + 16, tmargin + 16, 192, 32);
    add(labelFontTest);

	panelList = new List(12);
	panelList.setBounds(lmargin + 16, tmargin + 70, 112, 216);
    panelList.addItemListener(this);
	add(panelList);


	choiceWorkFont = new Choice();
	choiceWorkFont.setBounds(lmargin + 272, tmargin + 70, 164, 24);
    choiceWorkFont.addItemListener(this);
	add(choiceWorkFont);

	labelDisplayFont = new Label("Font",Label.RIGHT);
	labelDisplayFont.setBounds(lmargin + 202, tmargin + 70, 60, 22);
	add(labelDisplayFont);

	choiceWorkStyle = new Choice();
	choiceWorkStyle.setBounds(lmargin + 272, tmargin + 120,100, 24);
    choiceWorkStyle.addItemListener(this);
	add(choiceWorkStyle);

	labelDisplayStyle = new Label("Style",Label.RIGHT);
	labelDisplayStyle.setBounds(lmargin + 202, tmargin + 121, 60, 22);
	add(labelDisplayStyle);

	choiceWorkSize = new Choice();
	choiceWorkSize.setBounds(lmargin + 272, tmargin + 168, 56,24);
	choiceWorkSize.addItem("8");
	choiceWorkSize.addItem("9");
	choiceWorkSize.addItem("10");
	choiceWorkSize.addItem("11");
	choiceWorkSize.addItem("12");
	choiceWorkSize.addItem("13");
	choiceWorkSize.addItem("14");
	choiceWorkSize.addItem("15");
	choiceWorkSize.addItem("16");
 	choiceWorkSize.addItem("17");
	choiceWorkSize.addItem("18");
	choiceWorkSize.addItem("20");
	choiceWorkSize.addItem("24");
	choiceWorkSize.addItem("32");
    choiceWorkSize.addItemListener(this);
	add(choiceWorkSize);

	labelDisplaySize = new Label("Size", Label.RIGHT);
	labelDisplaySize.setBounds(lmargin + 202, tmargin + 169, 60, 24);
	add(labelDisplaySize);

	choiceWorkBg = new Choice();
	choiceWorkBg.setBounds(lmargin + 272, tmargin + 212 ,100, 24);
    choiceWorkBg.addItemListener(this);
	add(choiceWorkBg);

	labelDisplayBg = new Label("Background",Label.RIGHT);
	labelDisplayBg.setBounds(lmargin + 172, tmargin + 213, 88, 22);
	add(labelDisplayBg);

	choiceWorkFg = new Choice();
	choiceWorkFg.setBounds(lmargin + 272, tmargin + 264,100, 24);
    choiceWorkFg.addItemListener(this);
	add(choiceWorkFg);

	labelDisplayFg = new Label("Foreground",Label.RIGHT);
	labelDisplayFg.setBounds(lmargin + 172, tmargin + 265, 88, 22);
	add(labelDisplayFg);

    GraphicsEnvironment ge = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment();
    String[] fonts = ge.getAvailableFontFamilyNames();
    for (int i = 0; i < fonts.length; i++)
     {
      // if(!fonts[i].equalsIgnoreCase("Helvetica"))
       // if(!fonts[i].equalsIgnoreCase("Courier"))
         if(!fonts[i].equalsIgnoreCase("ZapfDingBats"))
   //       if(!fonts[i].equalsIgnoreCase("TimesRoman"))
   //    	   if(!fonts[i].equalsIgnoreCase("DialogInput"))
 	        choiceWorkFont.addItem(fonts[i]);
	 }

   StyleList.fill(choiceWorkStyle);
   ColorList.fillChoice(choiceWorkBg);
   ColorList.fillChoice(choiceWorkFg);

   maxItems = 0;
  }




 public void addNotify()
  {
   super.addNotify();

   Container parent = getParent();
   Color PrgColor = parent.getBackground();
   panelList.setBackground(PrgColor);
   choiceWorkFont.setBackground(PrgColor);
   choiceWorkSize.setBackground(PrgColor);
   choiceWorkStyle.setBackground(PrgColor);
   choiceWorkBg.setBackground(PrgColor);
   choiceWorkFg.setBackground(PrgColor);

  }


 /**
    Ajoute un style  la liste et une entre  panelList
 */

 public void addItem(Style style, String name, boolean mask)
  {
   panelList.add(name);
   styles.addElement((Object) style);
   masks.addElement(mask);
   maxItems++;

  }

 public void addItem(Style style, String name)
  {
   addItem(style, name, true);
  }

 // Futur,  voir
 // Quand on slectionne un composant et que l'on change
 // les valeurs, les fonctions setFont etc... sont utiliss
 /*
 public void addItem(Component component, String name)
 {
   panelList.add(name);
   styles.addElement((Object) component);
   masks.addElement(true);
   maxItems++;

 }
 */


 /**
    Dfinit le style courant affich
    A l'initialisation
 */

 public void setCurrentStyle(int no)
 {
   try { panelList.select(no); }
   catch(IllegalArgumentException i)
   { System.out.println("StylePanel " + no + " out of " + panelList.getItemCount()); }
   copyWork();
 }


 /**
     Le composant est affich
 */

 public void setVisible(boolean b)
   {
    super.setVisible(b);
    if(b) setFontTest(true);
   }

 // Pav font
 void setFontTest(boolean diff)
  {

     WorkStyle.makeColors(diff);
     WorkStyle.makeFont();

     labelFontTest.setStyle(WorkStyle);
     labelFontTest.repaint();
   }


  /**
      Copie un des styles de la liste dans le style de travail
   */

  void copyWork()
   {

     WorkStyle = (Style) styles.elementAt(Preferences.CurrentStyle);
     boolean mask = (boolean) masks.elementAt(Preferences.CurrentStyle);

     try {
       choiceWorkSize.select(WorkStyle.sSize);
	   choiceWorkFont.select(WorkStyle.sFont);
       choiceWorkStyle.select(WorkStyle.sStyle);
       choiceWorkBg.select(WorkStyle.sBackground);
       choiceWorkFg.select(WorkStyle.sForeground);
     }
     catch(IllegalArgumentException iae) { iae.printStackTrace(); }
     catch(Exception e) { System.out.println("StylePanel error in choice"); }

     choiceWorkSize.setEnabled(mask);
	 choiceWorkFont.setEnabled(mask);
     choiceWorkStyle.setEnabled(mask);
     choiceWorkFg.setEnabled(mask);

     WorkStyle.makeFont();
     setFontTest(true);

    }



  public void itemStateChanged(ItemEvent event)
   {
     Object object = event.getSource();

     //System.out.println(object.toString());

	 if(object == panelList) // Slection composant dont on veut changer le style
	  {
	 	 Preferences.CurrentStyle = (int) panelList.getSelectedIndex();
	 	 //System.out.println("no " + Preferences.CurrentStyle);
         copyWork();
         return;
	  }

	String strevent = (String) event.getItem();

	if(object == choiceWorkFont)  WorkStyle.sFont = strevent;
	else if(object == choiceWorkStyle) WorkStyle.sStyle = strevent;
    else if(object == choiceWorkSize)  WorkStyle.sSize = strevent;
    else if(object == choiceWorkBg)    WorkStyle.sBackground = strevent;
    else if(object == choiceWorkFg)    WorkStyle.sForeground = strevent;
    else return;

    // Copie le style d'interface dans le style source
    // slectionn, objet point dans le Vector
    // et affiche le pav de test

    styles.setElementAt((Object) WorkStyle, Preferences.CurrentStyle);
    setFontTest(false);
    sourceActionEvent(Preferences.CurrentStyle);
   }

    /**
     * Fire an action event to the listeners.
     */

	ActionListener actionListener = null;

	protected void sourceActionEvent(int action)
	{
	  if (actionListener == null) return;

	  String actionCommand = new Integer(action).toString();
	  actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, actionCommand));
	}

    /** Adds a to receive action events  */
	public void addActionListener(ActionListener l)
	{
		actionListener = AWTEventMulticaster.add(actionListener, l);
	}


}
