/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import common.*;

public class ThumbSetup extends Panel implements ActionListener, ItemListener
{
  
  TSpinner spinnerW;
  TSpinner spinnerH;
  
  DCheckbox checkBorder;
  DCheckbox checkName;
  DCheckbox checkSize;  
  DCheckbox checkType;

  Frame parent;


  public ThumbSetup(Frame parent)
  {
    super();
	setLayout(null);
	setVisible(false);

    this.parent = parent;
//   background = parent.getBackground();
//   setBackground(background);


    Label sl1 = new Label("Image width");
    sl1.setBounds(24, 30, 92, 20);
    add(sl1);

    spinnerW = new TSpinner(Preferences.ThumbWidth, 16, 256);
    spinnerW.setBounds(118, 30, 72, 20);
	spinnerW.addActionListener(this);		    
    add(spinnerW);

    Label sl2 = new Label("Cell width");
    sl2.setBounds(220, 30, 74, 20);
    add(sl2);
    
    spinnerH = new TSpinner(Preferences.ThumbCell, 16, 256);
    spinnerH.setBounds(304, 30, 72, 20);   
	spinnerH.addActionListener(this);		        
    add(spinnerH);

	checkBorder = new DCheckbox("Draw a border", Preferences.ThumbBorder);
	checkBorder.setBounds(20, 78, 132, 22);
	checkBorder.addItemListener(this);
	add(checkBorder);

	checkName = new DCheckbox("Display the names", Preferences.ThumbName);
	checkName.setBounds(20, 110 , 156, 22);
	checkName.addItemListener(this);		
    add(checkName);

	checkSize = new DCheckbox("Display the sizes", Preferences.ThumbSize);
	checkSize.setBounds(20, 142, 140, 22);
	checkSize.addItemListener(this);		
	add(checkSize);

	checkType = new DCheckbox("Display the types", Preferences.ThumbType);
	checkType.setBounds(20, 174, 140, 22);
	checkType.addItemListener(this);		
	add(checkType);

  }



  public void actionPerformed(java.awt.event.ActionEvent event)
	{
	 Object object = event.getSource();		
		
      if(object == spinnerW)
         Preferences.ThumbWidth = spinnerW.current; 
      else if(object == spinnerH)
         Preferences.ThumbCell = spinnerH.current;  
   }


    /**
     * Fire an action event to the listeners.
     */

	ActionListener actionListener = null;

	protected void sourceActionEvent(int action)
	{
	  if (actionListener == null) return;

	  String actionCommand = new Integer(action).toString();
	  actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, actionCommand));
	}

    /** Adds a to receive action events  */
	public void addActionListener(ActionListener l)
	{
		actionListener = AWTEventMulticaster.add(actionListener, l);
	}

    public void itemStateChanged(java.awt.event.ItemEvent event)
	 {
	   Object object = event.getSource();

		//String strevent = (String) event.getItem();

	   if (object == checkBorder)
		   Preferences.ThumbBorder = checkBorder.getState();
	   else if (object == checkName)
		   Preferences.ThumbName = checkName.getState();
	   else if (object == checkSize)
		   Preferences.ThumbSize = checkSize.getState();
	   else if (object == checkType)
		   Preferences.ThumbType = checkType.getState();
    }

}
