/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
//import java.net.*;


public class Thumbnail extends Component
{
  boolean bBorder;
  boolean bName;
  boolean bSize;
  boolean bType;

  int imageWidth;
  int imageHeight;
  int cellWidth;

  int width;
  int height;

  int rowSize;
  int nRows;
  int count;

  String names[];
//  String paths[];
  long sizes[];

  FileWriter fw;
  BufferedWriter bw;
  static int iBorder = 2;  // bord d'image

  static String g = "\"";

  public static String htmlFile = ""; // le fichier html
  public static String htmlName = ""; // le fichier html
  public static String htmlDir  = "";

  public Thumbnail(Dimension screen)
  {

    imageWidth = Preferences.ThumbWidth;
    cellWidth = Preferences.ThumbCell;
    bBorder = Preferences.ThumbBorder;
    bName = Preferences.ThumbName;
    bSize = Preferences.ThumbSize;
    bType = Preferences.ThumbType;

    width = screen.width;
    height = screen.height;

  }


 public Thumbnail(Dimension screen, String dir, String names[], long sizes[])
  {
    this(screen);
    setList(dir, names, sizes);
  }

 public void setList(String dir, String[] n, long s[])
 {
    names = n;
    sizes = s;
    count = n.length;
 }

 public Thumbnail(Dimension screen, DirBox d, int start, String dir)
 {
   this(screen);

   if (d.isSelected() || d.isTagged())
   {
    setList(dir, d.getSelectedItems(), d.getSelectedSizes());
    return;
   }

   int siz = d.items.size();
   int ctr = 0;

   ListItem li;
   VectorString vn = new VectorString();
   VectorLong vs = new VectorLong();

   for (int i = start; i < siz; i++)
    {
     li = (ListItem) d.items.elementAt(i);

     String name = li.sText;

     if( !(new File(dir, name)).isDirectory())
     {
      String ext = Path.getExtension(name);
      if(ext.equalsIgnoreCase("gif") ||
        ext.equalsIgnoreCase("jpg") ||
        ext.equalsIgnoreCase("bmp") ||
        ext.equalsIgnoreCase("xbm") ||
        ext.equalsIgnoreCase("png")
        )
      {
       vn.addElement(name);
       vs.addElement(d.VSize.elementAt(i));
       ctr++;
      }
    } //is dir
   }

   if(ctr > 0)
   {
    names = new String[ctr]; vn.copyInto(names);
    sizes = new long[ctr];   vs.copyInto(sizes);
    count = names.length;
   }
 }


 static public void setFile(String dir, String name)
 {
   htmlFile = Path.merge(dir, name);
   htmlDir  = dir;
   htmlName = name;
 }

 public String getFile() { return htmlFile; }

 private void put(String s)
 {
   try
   {
    bw.write(s, 0, s.length());
    bw.newLine();
   }
   catch(IOException i) { System.out.println("Enable to write " + s); }
 }


 public void resize(Image img)
 {
   MediaTracker tracker = new MediaTracker(this);
   tracker.addImage(img, 0);
   try { tracker.waitForAll(); }
   catch(InterruptedException e) { e.printStackTrace(); }
   int originW = img.getWidth(null);
   int originH = img.getHeight(null);

   imageHeight = (int) ( (float) originH * (float) imageWidth / (float) originW);
   //System.out.println(originW + "x" + originH + " -> " + imageWidth + "x" + imageHeight);
 }



// URL url = null;

 public void resize(String name)
 {
   if((new File(name)).isDirectory()) return;
/*
   try
   {
     URL address = new URL(url, name);
     resize(getToolkit().getImage(url));
     return;
   }
   catch(MalformedURLException m) { m.printStackTrace(); }
*/
   resize(getToolkit().getImage(name));
 }

 public void createTD(int no)
 {
//   resize(paths[no]);
   resize(names[no]);

   put("<TD width=" + g + cellWidth + g + "><br>");
   if(bBorder) put("<TABLE border =" + g + iBorder + g + "> <TD>");
   put("<A HREF=" + g  + names[no] + g +
           "> <IMG SRC=" + g + names[no] + g +
           " WIDTH=" +  g  + imageWidth + g +
           " HEIGHT=" + g + imageHeight + g +
           " BORDER=" + g + "0" + g +
           "> </A>");
   if(bBorder) put("</TD></TABLE>");
   put("</TD>");
 }


 public void createTDLabel(int no)
 {
   //System.out.println("td no=" + no);
   //System.out.println("td name " + names[no]);
   try
   {
   int pos = names[no].lastIndexOf(".");
   String node = names[no].substring(0, pos);

   put("<TD width=" + g + cellWidth + g + ">");
   if(bName)
   {
     put("<FONT SIZE=" + g + "1" + g +">");
     put("<b> " + node + " </b></FONT>");
   }

   if(bType || bSize)
   {
     put("<FONT SIZE=" + g + "-3" + g +">");
     if(bType) put("<br>" + names[no].substring(pos + 1));
     if(bSize) put("<br>" + sizes[no]);
     put("</FONT>");
   }

   put("</TD>");
   }
   catch(Exception e) { e.printStackTrace(); }
 }



 public void createTR(int start)
 {
   //System.out.println("tr " + start + " " + rowSize);
   put("<TR align=" + g + "center" + g + "> ");

   for(int r = 0; r < rowSize; r++)
   {
    int no = start + r;
    if(no < count) createTD(no);
   }
   put("</TR>");

   put("<TR align=" + g + "center" + g + "> ");

   for(int r = 0; r < rowSize; r++)
   {
    int no = start + r;
    if(no < count) createTDLabel(no);
   }

   put("</TR>");

 }


 public int createHtml()
 {
   int start = 0;

   if(count == 0) return 0;

   rowSize = Math.max(1, (width - 40) / cellWidth) ;
   nRows = Math.max(1, (count + rowSize) / rowSize);

   System.gc();
   //System.out.println("enter " + htmlFile);

   try
   {
     fw = new FileWriter(htmlFile);
     bw = new BufferedWriter(fw);
   }
   catch(IOException i) { System.out.println("Enable to make " + htmlFile); }


   put("<HTML>");
   put("<HEAD>");
   put("<TITLE>Thumbnail</TITLE>");

   put("<STYLE TYPE=" + g + "text/css" + g + " MEDIA=screen >");
   put("<!--");
   put(" BODY { font-family: " + g + "Courrier New" + g + ", Courrier, mono, Monospaced, Arial  }");
   put("-->");
   put("</STYLE>");

   put("</HEAD>");
   if(Preferences.pageColor.equalsIgnoreCase("None"))
    put("<BODY>");
   else
    put("<BODY bgcolor=" + Preferences.pageColor + ">");

   put("<TABLE CELLSPACING="+ g + "4" + g +
               " CELLPADDING="+ g + "0" + g +
               " BORDER=" + g + "0" + g + " >");

   //System.out.println("nrows = " + nRows);
   for(int r = 0; r < nRows; r++)
   {
    createTR(start);
    start += rowSize;
   }

   put("</TABLE>");
   put("</BODY>");
   put("</HTML>");

   try { bw.close(); }
   catch(IOException ic) { ic.printStackTrace(); }

   return count;
 }
}
