/*
    Advanced Explorer (c) 1999-2006 by D.G. Sureau

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    webmaster@scriptol.org
    http://www.scriptol.org
*/
package common;

import java.awt.*;
import java.util.*;
import java.io.File;
import java.lang.IllegalArgumentException;

import common.VectorString;
import common.Style;

public class Tool
{
  static boolean beepOn = true;

   // digitsize = longueur maximale du nombre de digits

   public static String longToString(long size) { return longToString(size, 9); }
   public static String longToString(long size, int digitsize)
   {
	 StringBuffer buf = new StringBuffer(digitsize);
     int l;
     int i;
     int n;

	 size = - size;
	 while (size <= -10)
	 {
	    buf.append(Character.forDigit((int)(-(size % 10)), 10));
	    size = size / 10;
	 }
 	 buf.append(Character.forDigit((int)(-size), 10));

//     return new String(buf.reverse());

	 l = buf.length();
	 n = l;
     char str[] = new char[l];
	 for(i = 0; i < l; i++)  str[i] = buf.charAt(--n);

     return new String(str);

    }


 /**
    Transfre les tokens d'une chaine
    dans un tableau de tokens
   */

 static public String [] Tokenize(String source)
 {
  StringTokenizer st = new StringTokenizer(source, " ");
  VectorString vs = new VectorString();

  while(st.hasMoreTokens()) vs.addElement(st.nextToken());

  return vs.toArray();
 }


  /**
    Attente de d millisecondes
    */
  public static void delay(int d)
  {
    try
    {
      Thread.sleep(d);
    }
    catch(InterruptedException ie){}
  }

  /**
    Compare deux objets
    */
  public static boolean objectsEqual(Object objectA, Object objectB)
   {
		if (objectA == null) return (objectB == null);
		return objectA.equals(objectB);
   }


  static public void setBeep(boolean onOff) { beepOn = onOff; }

  static public void beep()
   {
     if(beepOn)  Toolkit.getDefaultToolkit().beep();
   }

  static public boolean exists(String name)
  {
    return ( new File(name)).exists() ;
  }

  static public boolean exists(String name, long len, long lm)
  {
    File f = new File(name);
    if(f.exists())
    {
     //Disp.it("len " + f.length() + "=" + len);
     //Disp.it("lm  " + f.lastModified() + "=" + lm);
     if(f.length() != len) return false;
     if(f.lastModified() != lm) return false;
     return true;
    }
    return false;
  }

	/**
	 * Checks to make sure the percent parameter is in range.
	 */
	public static void checkValidPercent(double percent)
	{
		if(percent > 1 || percent < 0)
		throw new IllegalArgumentException(percent + " is not a valid percentage value. It should be <= 1 && >= 0");
	}


    /**
        Affiche un message dans un rectangle sur l'image
    */
	static void drawTip(Graphics g, int x, int y, String disp)
 	{
	 final int border = 1;

	 FontMetrics screenFM = g.getFontMetrics();

	 int a = screenFM.getAscent();
	 int d = screenFM.getHeight() - a;
	 int h = a + d + (border << 1);
	 int w = screenFM.stringWidth(disp) + (d << 1) + (border << 1);

	 g.setColor(Color.yellow);
	 g.fillRect(x, y, w, h);
	 g.setColor(Color.black);
	 g.drawRect(x, y, w, h);
	 g.drawString(disp, x + d + border, y + a + border);

    }


}
